import io.cucumber.java.After;
import io.cucumber.java.Before;
import io.cucumber.java.Scenario;
import io.cucumber.java.en.Given;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.junit.Assert;
import org.openqa.selenium.*;
import org.openqa.selenium.chrome.ChromeDriver;

public class Amazon_search_steps
{
    private WebDriver driver;

    @Before
    public void setUp()
    {
           System.setProperty("webdriver.chrome.driver", "/usr/local/bin/ChromeDriver");
           driver = new ChromeDriver();
    }

    @After
    public void tearDown(Scenario scenario)
    {
           if(scenario.isFailed())
           {
               final byte[] screenshot = ((TakesScreenshot)driver).getScreenshotAs(OutputType.BYTES);
               scenario.attach(screenshot, "image/png", "amazon");
           }

           closeBrowser();
    }

    @Given("^I navigated to Google$")
    public void i_navigated_to_google() throws Throwable
    {
           driver.get("http://www.google.com");
    }

    @When("^I searched for Amazon$")
    public void i_searched_for_amazon()
    {
           WebElement searchBar = driver.findElement(By.name("q"));
           searchBar.sendKeys("Amazon");
           searchBar.submit();
    }

    @Then("the result should show for Amazon")
    public void the_result_should_show_for_amazon()
    {
           Assert.assertTrue(driver.getTitle().contains("Amazon"));
    }

    void closeBrowser()
    {
         driver.quit();
    }
}
