import io.cucumber.datatable.DataTable;
import io.cucumber.java.en.Given;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import io.restassured.RestAssured;
import io.restassured.response.Response;

import java.util.List;
import java.util.Map;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;



public class CatFactsSteps
{
    private String   url;
    private Response response;

    @Given("^the client makes a call to the hero ku$")
    public void the_client_makes_a_call_to_the_hero_ku() throws Throwable
    {
           url = "https://cat-fact.herokuapp.com";
    }

    @When("^the user calls the api for facts$")
    public void the_user_calls_the_api_with_facts() throws Throwable
    {
           response = RestAssured.given().baseUri(url).basePath("/facts").get().then().log().status().extract().response();
    }

    @Then("^the client receives status of (\\d+)$")
    public void the_client_receives_status_of(int arg1) throws Throwable
    {
           assertEquals(arg1, response.getStatusCode());
    }

    @Then("^the response has the text$")
    public void the_response_has_the_text(DataTable data) throws Throwable
    {
        List<Map<String, String>> rows = data.asMaps(String.class, String.class);

        for (Map<String, String> row : rows)
        {
            String text = row.get("text");
            assertTrue(response.getBody().asString().contains(text));
        }
    }
}
